MODULE_NAME='AustralianMonitor_AMDX00_UI'(DEV vdvDEVICE, DEV dvTP, INTEGER nCHAN_BTN[], INTEGER nTXT_BTN[])

(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 01/30/2003 AT: 08:51:36               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 12/19/2003 AT: 09:07:56         *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 17/02/2011                              *)
(*                                                         *)

(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT


(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE
(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE CHAR sVERSION[5]               // STORES NETLINX COMM MODULE VERSION NUMBER
VOLATILE INTEGER nENABLE_FDR_LEVEL = 1   // INDICATES IF THE CROSSPOINT LEVEL IS READY OR NOT


integer iMuteStatus[12]
integer iBGMSource
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING
(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
DEFINE_FUNCTION SLONG Scale_Range(SLONG Num_In, SLONG Min_In, SLONG Max_In, SLONG Min_Out, SLONG Max_Out)
{
    STACK_VAR
    SLONG Val_In
    SLONG Range_In
    SLONG Range_Out
    SLONG Whole_Num
    FLOAT Num_Out
    
    Val_In = Num_In                 // Get input value
    IF(Val_In == Min_In)            // Handle endpoints
        {Num_Out = Min_Out}
    ELSE IF(Val_In == Max_In)
        {Num_Out = Max_Out}
    ELSE                            // Otherwise scale...
    {
        Range_In = Max_In - Min_In      // Establish input range
        Range_Out = Max_Out - Min_Out   // Establish output range
        Val_In = Val_In - Min_In        // Remove input offset
        Num_Out = Val_In * Range_Out    // Multiply by output range
        Num_Out = Num_Out / Range_In    // Then divide by input range
        Num_Out = Num_Out + Min_Out     // Add in minimum output value
        Whole_Num = TYPE_CAST(Num_Out)  // Store the whole number only of the result
        IF (((Num_Out - Whole_Num)* 100.0) >= 50.0) { Num_Out++ }    // round up
    }
    Return TYPE_CAST(Num_Out)
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START


(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT[vdvDEVICE]
{
    STRING:
    {
        STACK_VAR CHAR cCMD[35]
        STACK_VAR INTEGER nCHANNEL
        
        SEND_STRING 0, "'UI RECEIVED FROM COMM: ',DATA.TEXT"
		  
		  
        IF(FIND_STRING(DATA.TEXT, '=', 1)) { cCMD = REMOVE_STRING(DATA.TEXT, '=', 1) }        
        ELSE { cCMD = DATA.TEXT }
		  
        SWITCH(cCMD)
        {
            // FIND MATCHING STRING AND PARSE REST OF MESSAGE. PROVIDE FEEDBACK TO THE 
            // TOUCH PANEL.
            CASE 'FADER=':  // FADER=1:1
            {
					STACK_VAR integer fVALUE
					
					nCHANNEL = atoi(DATA.TEXT)
					REMOVE_STRING(DATA.TEXT, ':', 1)
					fVALUE = atoi(DATA.TEXT)
					
					// range 0-255
					SEND_LEVEL dvTP, nCHANNEL, fVALUE
					
					send_string 0,"'level ch: ',itoa(nCHANNEL),' value: ',itoa(fVALUE)"
					
					nENABLE_FDR_LEVEL=0
					CANCEL_WAIT 'ENABLE CP LEVEL'
					WAIT 3 'ENABLE CP LEVEL' { nENABLE_FDR_LEVEL = 1 } // REMOVES UNDESIRABLE ECHO FEEDBACK
            }
            
				CASE 'MUTE=':  // FADER=1:1
            {
					STACK_VAR integer fVALUE
					
					nCHANNEL = ATOI(DATA.TEXT)
					REMOVE_STRING(DATA.TEXT, ':', 1)
					fVALUE = atoi(DATA.TEXT)
						
					send_string 0,"'UIrx MUTE ch: ',itoa(nCHANNEL),' value: ',itoa(fVALUE)"
					
					iMuteStatus[nCHANNEL] = fVALUE
				}
				
				CASE 'BGMSOURCE=':  // FADER=1:1
            {
					STACK_VAR integer fVALUE
					
					fVALUE = ATOI(DATA.TEXT)
						
					send_string 0,"'BGMSource: ',itoa(fVALUE)"
					
					iBGMSource = fVALUE
				}
				
				
				
            CASE 'VERSION=': { sVERSION = DATA.TEXT }
        }// END SWITCH(cCMD)
    }// END STRING
}// END DATA_EVENT[vdvDEVICE]


// TP Button Events
BUTTON_EVENT[dvTP, nCHAN_BTN]
{
    PUSH:
    {
        STACK_VAR INTEGER nBTN        
        nBTN = GET_LAST(nCHAN_BTN)
		  
        SWITCH(nBTN)
        {    
				// Mic/Line 1
            CASE 1:
                SEND_COMMAND vdvDEVICE,"'FADER=1:UP'"
            CASE 2:
                SEND_COMMAND vdvDEVICE,"'FADER=1:DOWN'" 
				
				// Mic/Line 2
            CASE 3:
                SEND_COMMAND vdvDEVICE,"'FADER=2:UP'"
            CASE 4:
                SEND_COMMAND vdvDEVICE,"'FADER=2:DOWN'"
				
				// Mic/Line 3
            CASE 5:
                SEND_COMMAND vdvDEVICE,"'FADER=3:UP'"
            CASE 6:
                SEND_COMMAND vdvDEVICE,"'FADER=3:DOWN'"
				
				// Mic/Line 4
            CASE 7:
                SEND_COMMAND vdvDEVICE,"'FADER=4:UP'"
            CASE 8:
                SEND_COMMAND vdvDEVICE,"'FADER=4:DOWN'"
					 
				// Mic/Line 5
            CASE 9:
                SEND_COMMAND vdvDEVICE,"'FADER=5:UP'"
            CASE 10:
                SEND_COMMAND vdvDEVICE,"'FADER=5:DOWN'"
				
				// Mic/Line 6
            CASE 11:
                SEND_COMMAND vdvDEVICE,"'FADER=6:UP'"
            CASE 12:
                SEND_COMMAND vdvDEVICE,"'FADER=6:DOWN'"
				
				// Mic/Line 7
            CASE 13:
                SEND_COMMAND vdvDEVICE,"'FADER=7:UP'"
            CASE 14:
                SEND_COMMAND vdvDEVICE,"'FADER=7:DOWN'"
				
				// Mic/Line 8
            CASE 15:
                SEND_COMMAND vdvDEVICE,"'FADER=8:UP'"
            CASE 16:
                SEND_COMMAND vdvDEVICE,"'FADER=8:DOWN'"
				
				// Stero BGM
            CASE 17:
                SEND_COMMAND vdvDEVICE,"'FADER=9:UP'"
            CASE 18:
                SEND_COMMAND vdvDEVICE,"'FADER=9:DOWN'"
				
				// Bass
            CASE 19:
                SEND_COMMAND vdvDEVICE,"'FADER=10:UP'"
            CASE 20:
                SEND_COMMAND vdvDEVICE,"'FADER=10:DOWN'"
				
				// Treble
            CASE 21:
					SEND_COMMAND vdvDEVICE,"'FADER=11:UP'"
            CASE 22:
					SEND_COMMAND vdvDEVICE,"'FADER=11:DOWN'"
				
				// Master Vol
            CASE 23:
                SEND_COMMAND vdvDEVICE,"'FADER=12:UP'"
            CASE 24:
                SEND_COMMAND vdvDEVICE,"'FADER=12:DOWN'"
				
				// SOURCE SELECTION
				CASE 26: // Source 1
				{
					iBGMSource = 1
					SEND_COMMAND vdvDEVICE,"'BGMSOURCE=',itoa(iBGMSource)"
				}
				CASE 27: // Source 2
				{
					iBGMSource = 2
					SEND_COMMAND vdvDEVICE,"'BGMSOURCE=',itoa(iBGMSource)"
				}
				CASE 28: // Source 3
				{
					iBGMSource = 3
					SEND_COMMAND vdvDEVICE,"'BGMSOURCE=',itoa(iBGMSource)"
				}
				CASE 29: // Source 4
				{
					iBGMSource = 4
					SEND_COMMAND vdvDEVICE,"'BGMSOURCE=',itoa(iBGMSource)"
				}
				CASE 30: // Source Off
				{
					iBGMSource = 0
					SEND_COMMAND vdvDEVICE,"'BGMSOURCE=',itoa(iBGMSource)"
				}
				
				// Mute/Bypass
				CASE 31: // Mic/Line 1
				{
					iMuteStatus[1] = !iMuteStatus[1]
					SEND_COMMAND vdvDEVICE,"'MUTE=1:',itoa(iMuteStatus[1])"					 
				}
				CASE 32: // Mic/Line 2
				{
					iMuteStatus[2] = !iMuteStatus[2]
					SEND_COMMAND vdvDEVICE,"'MUTE=2:',itoa(iMuteStatus[2])"					 
				}
				CASE 33: // Mic/Line 3
				{
					iMuteStatus[3] = !iMuteStatus[3]
					SEND_COMMAND vdvDEVICE,"'MUTE=3:',itoa(iMuteStatus[3])"					 
				}
				CASE 34: // Mic/Line 4
				{
					iMuteStatus[4] = !iMuteStatus[4]
					SEND_COMMAND vdvDEVICE,"'MUTE=4:',itoa(iMuteStatus[4])"					 
				}
				CASE 35: // Mic/Line 5
				{
					iMuteStatus[5] = !iMuteStatus[5]
					SEND_COMMAND vdvDEVICE,"'MUTE=5:',itoa(iMuteStatus[5])"					 
				}
				CASE 36: // Mic/Line 6
				{
					iMuteStatus[6] = !iMuteStatus[6]
					SEND_COMMAND vdvDEVICE,"'MUTE=6:',itoa(iMuteStatus[6])"					 
				}
				CASE 37: // Mic/Line 7
				{
					iMuteStatus[7] = !iMuteStatus[7]
					SEND_COMMAND vdvDEVICE,"'MUTE=1:',itoa(iMuteStatus[7])"					 
				}
				CASE 38: // Mic/Line 8
				{
					iMuteStatus[8] = !iMuteStatus[8]
					SEND_COMMAND vdvDEVICE,"'MUTE=8:',itoa(iMuteStatus[8])"					 
				}
				CASE 39: // Stereo BGM
				{
					iMuteStatus[9] = !iMuteStatus[9]
					SEND_COMMAND vdvDEVICE,"'MUTE=9:',itoa(iMuteStatus[9])"					 
				}
				CASE 40: // Bass
				{
					iMuteStatus[10] = !iMuteStatus[10]
					SEND_COMMAND vdvDEVICE,"'MUTE=10:',itoa(iMuteStatus[10])"					 
				}
				CASE 41: // Treble
				{
					iMuteStatus[11] = !iMuteStatus[11]
					SEND_COMMAND vdvDEVICE,"'MUTE=11:',itoa(iMuteStatus[11])"					 
				}
				CASE 42: // Master Mute
				{
					iMuteStatus[12] = !iMuteStatus[12]
					SEND_COMMAND vdvDEVICE,"'MUTE=12:',itoa(iMuteStatus[12])"					 
				}
        }
    }

	 RELEASE:
	 {
		STACK_VAR INTEGER nBTN        
		nBTN = GET_LAST(nCHAN_BTN)
		  
		SWITCH(nBTN)
        {    
				// Mic/Line 1
            CASE 1:
            CASE 2:
                SEND_COMMAND vdvDEVICE,"'FADER=1:STOP'" 
				
				// Mic/Line 2
            CASE 3:
            CASE 4:
                SEND_COMMAND vdvDEVICE,"'FADER=2:STOP'"
				
				// Mic/Line 3
            CASE 5:
            CASE 6:
                SEND_COMMAND vdvDEVICE,"'FADER=3:STOP'"
				
				// Mic/Line 4
            CASE 7:
            CASE 8:
                SEND_COMMAND vdvDEVICE,"'FADER=4:STOP'"
					 
				// Mic/Line 5
            CASE 9:
            CASE 10:
                SEND_COMMAND vdvDEVICE,"'FADER=5:STOP'"
				
				// Mic/Line 6
            CASE 11:
            CASE 12:
                SEND_COMMAND vdvDEVICE,"'FADER=6:STOP'"
				
				// Mic/Line 7
            CASE 13:
            CASE 14:
                SEND_COMMAND vdvDEVICE,"'FADER=7:STOP'"
				
				// Mic/Line 8
            CASE 15:
            CASE 16:
                SEND_COMMAND vdvDEVICE,"'FADER=8:STOP'"
				
				// Stero BGM
            CASE 17:
            CASE 18:
                SEND_COMMAND vdvDEVICE,"'FADER=9:STOP'"
				
				// Bass
            CASE 19:
            CASE 20:
                SEND_COMMAND vdvDEVICE,"'FADER=10:STOP'"
				
				// Treble
            CASE 21:
            CASE 22:
					SEND_COMMAND vdvDEVICE,"'FADER=11:STOP'"
				
				// Master Vol
            CASE 23:
            CASE 24:
                SEND_COMMAND vdvDEVICE,"'FADER=12:STOP'"
        }
	 }
	 
}// END BUTTON_EVENT[dvTP, nCHAN_BTN]


(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM


// Mute/Bypass Feedback
[dvTP,31] = (iMuteStatus[1]==1)
[dvTP,32] = (iMuteStatus[2]==1)
[dvTP,33] = (iMuteStatus[3]==1)
[dvTP,34] = (iMuteStatus[4]==1)
[dvTP,35] = (iMuteStatus[5]==1)
[dvTP,36] = (iMuteStatus[6]==1)
[dvTP,37] = (iMuteStatus[7]==1)
[dvTP,38] = (iMuteStatus[8]==1)
[dvTP,39] = (iMuteStatus[9]==1)
[dvTP,40] = (iMuteStatus[10]==1)
[dvTP,41] = (iMuteStatus[11]==1)
[dvTP,42] = (iMuteStatus[12]==1)

// BGMSource
[dvTP,30] = (iBGMSource==0)
[dvTP,26] = (iBGMSource==1)
[dvTP,27] = (iBGMSource==2)
[dvTP,28] = (iBGMSource==3)
[dvTP,29] = (iBGMSource==4)

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)